#include <bits/stdc++.h>
using namespace std;

int main(){
	ios_base::sync_with_stdio(false), cin.tie(nullptr);
	int N;
	cin >> N;
	vector<int> minbox(3, 1e5);
	for(int i = 0; i < N; i++){
		vector<int> a(3);
		for(int j = 0; j < 3; j++){
			cin >> a[j];
		}
		sort(a.begin(), a.end());
		for(int j = 0; j < 3; j++){
			minbox[j] = min(minbox[j], a[j]);
		}
	}
	int ans = 1;
	for(int x : minbox) ans *= x;
	cout << ans << '\n';
}
